package id.co.sangkuriang.inovasi.daerah.master.controller

import id.co.sangkuriang.inovasi.daerah.master.constant.UPLOAD_ICON_APPLICATION_CATEGORY_DIR
import id.co.sangkuriang.inovasi.daerah.master.constant.UPLOAD_IMAGE_APPLICATION_CATEGORY_DIR
import id.co.sangkuriang.inovasi.daerah.master.exception.NotFoundException
import org.apache.commons.io.IOUtils
import org.springframework.http.MediaType
import org.springframework.stereotype.Controller
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RequestMethod
import org.springframework.web.bind.annotation.RequestParam
import org.springframework.web.bind.annotation.ResponseBody
import java.io.File
import java.io.FileInputStream
import javax.servlet.http.HttpServletResponse

@Controller
@RequestMapping("file")
class FileController {

    @RequestMapping(
        value = ["images"],
        method = [RequestMethod.GET],
        produces = [MediaType.IMAGE_JPEG_VALUE, MediaType.IMAGE_PNG_VALUE]
    )
    @ResponseBody
    fun images(
        @RequestParam type: String,
        @RequestParam fileName: String,
        response: HttpServletResponse
    ): ByteArray? {
        var fis: FileInputStream? = null
        try {
            var dir = ""
            when (type) {
                "application-category-icon" -> {
                    dir = UPLOAD_ICON_APPLICATION_CATEGORY_DIR
                }
                "application-category-image" -> {
                    dir = UPLOAD_IMAGE_APPLICATION_CATEGORY_DIR
                }
            }

            val file = File(dir + File.separator + fileName)
            if (file.exists()) {
                fis = FileInputStream(file)
                return IOUtils.toByteArray(fis)
            }

            throw NotFoundException()
        } catch (e: Exception) {
            throw e
        } finally {
            fis?.close()
        }
    }
}
