package id.co.sangkuriang.inovasi.daerah.master.controller

import id.co.sangkuriang.inovasi.daerah.master.model.request.DeleteDataRequest
import id.co.sangkuriang.inovasi.daerah.master.model.request.Pagination2Request
import id.co.sangkuriang.inovasi.daerah.master.model.request.PaginationRequest
import id.co.sangkuriang.inovasi.daerah.master.pojo.Province
import id.co.sangkuriang.inovasi.daerah.master.service.ProvinceService
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.http.ResponseEntity
import org.springframework.web.bind.annotation.*
import javax.validation.Valid

@RestController
@RequestMapping(path = ["province"])
class ProvinceController {

    @Autowired
    private lateinit var service: ProvinceService

    @GetMapping(value = [""], produces = ["application/json"])
    fun getAll(page: PaginationRequest): ResponseEntity<*>? {
        return service.getAll(page)
    }

    @PostMapping(value = ["datatable"], produces = ["application/json"])
    fun datatable(@RequestBody req: Pagination2Request): ResponseEntity<*>? {
        return service.datatable(req)
    }

    @GetMapping(value = ["{id}"], produces = ["application/json"])
    fun getDetail(@PathVariable id: String): ResponseEntity<*>? {
        return service.getDetail(id)
    }

    @PostMapping(value = [""], produces = ["application/json"])
    fun saveData(@Valid @RequestBody request: Province): ResponseEntity<*>? {
        return service.saveData(request)
    }

    @PutMapping(value = ["{id}"], produces = ["application/json"])
    fun updateData(@PathVariable id: String, @Valid @RequestBody request: Province): ResponseEntity<*>? {
        return service.updateData(id, request)
    }

    @DeleteMapping(value = [""], produces = ["application/json"])
    fun deleteData(@Valid @RequestBody request: DeleteDataRequest): ResponseEntity<*>? {
        return service.deleteData(request)
    }
}
