package id.co.sangkuriang.inovasi.daerah.master.exception

import org.springframework.http.HttpStatus

/**
 *
 * response status code indicates that the server cannot or will not process
 * the request due to something that is perceived to be a client error
 * (e.g., malformed request syntax, invalid request message framing, or deceptive request routing).
 */
class BadRequestException : BaseException {

    constructor(message: String? = "Bad Request") {
        this.code = "400"
        this.message = message!!
        this.status = HttpStatus.BAD_REQUEST
    }

    constructor(message: String? = "Bad Request", data: Any?) {
        this.code = "400"
        this.message = message!!
        this.status = HttpStatus.BAD_REQUEST
        this.data = data
    }

}
