package id.co.sangkuriang.inovasi.daerah.master.pojo

import com.fasterxml.jackson.annotation.JsonFormat
import com.fasterxml.jackson.annotation.JsonIgnore
import java.util.*
import javax.persistence.*

@Entity
@Table(name = "users")
data class Users(
    @Id
    @Column(name = "id")
    var id: String? = UUID.randomUUID().toString(),

    @Column(name = "nik")
    var nik: String? = null,

    @Column(name = "nip")
    var nip: String? = null,

    @Column(name = "password")
    @JsonIgnore
    var password: String? = null,

    @Column(name = "full_name")
    var fullName: String? = null,

    @Column(name = "image")
    var image: String? = null,

    @Column(name = "phone_number")
    var phoneNumber: String? = null,

    @Column(name = "email")
    var email: String? = null,

    @Column(name = "role_id")
    var roleId: String? = null,

    @ManyToOne(cascade = [CascadeType.MERGE])
    @JoinColumn(name = "role_id", insertable = false, updatable = false, nullable = true)
    var role: Role? = null,

    @Column(name = "province_id")
    var provinceId: String? = null,

    @ManyToOne(optional = true, fetch = FetchType.LAZY)
    @JoinColumn(name = "province_id", insertable = false, updatable = false, nullable = true)
    var province: Province? = null,

    @Column(name = "regency_id")
    var regencyId: String? = null,

    @ManyToOne(optional = true, fetch = FetchType.LAZY)
    @JoinColumn(name = "regency_id", insertable = false, updatable = false, nullable = true)
    var regency: Regency? = null,

    @Column(name = "confirmed")
    @JsonIgnore
    var confirmed: Boolean? = false,

    @Column(name = "confirmed_date")
    @get:JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "dd-MM-yyyy HH:mm:ss", timezone = "GMT+7")
    @JsonIgnore
    var confirmedDate: Date? = null,

    @Column(name = "logged_in")
    @JsonIgnore
    var loggedIn: Boolean? = false,

    @Column(name = "created_at")
    @get:JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "dd-MM-yyyy HH:mm:ss", timezone = "GMT+7")
    var createdAt: Date? = Date(),

    @Column(name = "updated_at")
    @get:JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "dd-MM-yyyy HH:mm:ss", timezone = "GMT+7")
    var updatedAt: Date? = Date(),

    @get:JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "dd-MM-yyyy HH:mm:ss", timezone = "GMT+7")
    var lastLogin: Date? = Date(),

    @Column(name = "active")
    @JsonIgnore
    var active: Boolean? = true
)
