package id.co.sangkuriang.inovasi.daerah.master.repository

import id.co.sangkuriang.inovasi.daerah.master.pojo.ApplicationCategory
import org.springframework.data.domain.Page
import org.springframework.data.domain.Pageable
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.data.jpa.repository.Query
import org.springframework.data.repository.query.Param
import java.util.*

interface ApplicationCategoryRepository : JpaRepository<ApplicationCategory, String> {

    @Query(
        "SELECT u FROM ApplicationCategory u " +
                "WHERE u.active = true " +
                "AND (LOWER(u.name) LIKE %:param%)"
    )
    fun getListPagination(@Param("param") param: String?, pageable: Pageable?): Page<ApplicationCategory?>?

    fun findByIdAndActive(id: String?, active: Boolean = true): Optional<ApplicationCategory>

    @Query("FROM ApplicationCategory WHERE LOWER(name) = LOWER(:name) AND active = true")
    fun findByName(name: String?): Optional<ApplicationCategory>

    @Query("SELECT COUNT(u) FROM ApplicationCategory u WHERE u.active = true")
    fun getCount(): Long?
}
