package id.co.sangkuriang.inovasi.daerah.master.repository

import id.co.sangkuriang.inovasi.daerah.master.pojo.Province
import org.springframework.data.domain.Page
import org.springframework.data.domain.Pageable
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.data.jpa.repository.Query
import org.springframework.data.repository.query.Param
import java.util.*

interface ProvinceRepository : JpaRepository<Province, String> {

    @Query(
        "SELECT u FROM Province u " +
                "WHERE u.active = true " +
                "AND (LOWER(u.name) LIKE %:param%)"
    )
    fun getListPagination(@Param("param") param: String?, pageable: Pageable?): Page<Province?>?

    fun findByIdAndActive(id: String?, active: Boolean = true): Optional<Province>

    @Query("FROM Province WHERE LOWER(name) = LOWER(:name) AND active = true")
    fun findByName(name: String?): Optional<Province>

    @Query("SELECT COUNT(u) FROM Province u WHERE u.active = true")
    fun getCount(): Long?
}
