package id.co.sangkuriang.inovasi.daerah.master.repository

import id.co.sangkuriang.inovasi.daerah.master.pojo.Regency
import org.springframework.data.domain.Page
import org.springframework.data.domain.Pageable
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.data.jpa.repository.Query
import org.springframework.data.repository.query.Param
import java.util.*

interface RegencyRepository : JpaRepository<Regency, String> {

    @Query(
        "SELECT u FROM Regency u " +
                "WHERE u.active = true " +
                "AND (LOWER(u.name) LIKE %:param%)"
    )
    fun getListPagination(@Param("param") param: String?, pageable: Pageable?): Page<Regency?>?

    fun findByIdAndActive(id: String?, active: Boolean = true): Optional<Regency>

    @Query("FROM Regency WHERE LOWER(name) = LOWER(:name) AND provinceId = :provinceId AND active = true")
    fun findByNameProvinceId(name: String?, provinceId: String?): Optional<Regency>
}
