package id.co.sangkuriang.inovasi.daerah.master.repository

import id.co.sangkuriang.inovasi.daerah.master.pojo.Tag
import org.springframework.data.domain.Page
import org.springframework.data.domain.Pageable
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.data.jpa.repository.Query
import org.springframework.data.repository.query.Param
import java.util.*

interface TagRepository : JpaRepository<Tag, String> {

    @Query(
        "SELECT t FROM Tag t " +
                "WHERE t.active = true " +
                "AND (LOWER(t.name) LIKE %:param%)"
    )
    fun getListPagination(@Param("param") param: String?, pageable: Pageable?): Page<Tag?>?

    fun findByIdAndActive(id: String?, active: Boolean = true): Optional<Tag>

    @Query("FROM Tag WHERE LOWER(name) = LOWER(:name) AND active = true")
    fun findByName(name: String?): Optional<Tag>
}
